import React from "react";
import Types from "prop-types";
/**
 * Leaf.
 *
 * @type {Component}
 */
declare class Leaf extends React.Component<any, any> {
    /**
     * Property types.
     *
     * @type {Object}
     */
    static propTypes: {
        block: (...args: any[]) => Error | null;
        editor: Types.Validator<object>;
        index: Types.Validator<number>;
        leaves: (...args: any[]) => Error | null;
        marks: (...args: any[]) => Error | null;
        node: (...args: any[]) => Error | null;
        offset: Types.Validator<number>;
        parent: (...args: any[]) => Error | null;
        text: Types.Validator<string>;
    };
    /**
     * Debug.
     *
     * @param {String} message
     * @param {Mixed} ...args
     */
    debug: (message: any, ...args: any[]) => void;
    /**
     * Should component update?
     *
     * @param {Object} props
     * @return {Boolean}
     */
    shouldComponentUpdate(props: any): boolean;
    /**
     * Render the leaf.
     *
     * @return {Element}
     */
    render(): JSX.Element;
    /**
     * Render all of the leaf's mark components.
     *
     * @return {Element}
     */
    renderMarks(): any;
    /**
     * Render the text content of the leaf, accounting for browsers.
     *
     * @return {Element}
     */
    renderText(): any;
}
/**
 * Export.
 *
 * @type {Component}
 */
export default Leaf;
