import React from "react";
import Types from "prop-types";
/**
 * Node.
 *
 * @type {Component}
 */
declare class Node extends React.Component<any, any> {
    /**
     * Property types.
     *
     * @type {Object}
     */
    static propTypes: {
        block: ((...args: any[]) => Error | null) & {
            isRequired: (...args: any[]) => Error | null;
        };
        decorations: Validator<any>;
        editor: Types.Validator<object>;
        isFocused: Types.Validator<boolean>;
        isSelected: Types.Validator<boolean>;
        node: (...args: any[]) => Error | null;
        parent: (...args: any[]) => Error | null;
        readOnly: Types.Validator<boolean>;
    };
    /**
     * Debug.
     *
     * @param {String} message
     * @param {Mixed} ...args
     */
    debug: (message: any, ...args: any[]) => void;
    /**
     * Should the node update?
     *
     * @param {Object} nextProps
     * @param {Object} value
     * @return {Boolean}
     */
    shouldComponentUpdate(nextProps: any): boolean;
    /**
     * Render.
     *
     * @return {Element}
     */
    render(): any;
    /**
     * Render a `child` node.
     *
     * @param {Node} child
     * @param {Boolean} isSelected
     * @param {Array<Decoration>} decorations
     * @return {Element}
     */
    renderNode: (child: any, isSelected: any, decorations: any) => JSX.Element;
}
/**
 * Export.
 *
 * @type {Component}
 */
export default Node;
