import _parseInt from "@babel/runtime-corejs3/core-js-stable/parse-int";

/**
 * Offset key parser regex.
 *
 * @type {RegExp}
 */
var PARSER = /^([\w-]+)(?::(\d+))?$/;
/**
 * Parse an offset key `string`.
 *
 * @param {String} string
 * @return {Object}
 */

function parse(string) {
  var matches = PARSER.exec(string);

  if (!matches) {
    throw new Error("Invalid offset key string \"" + string + "\".");
  } // tslint:disable-next-line:no-unused-variable


  var original = matches[0],
      key = matches[1],
      index = matches[2];
  console.log(original);
  return {
    key: key,
    index: _parseInt(index, 10)
  };
}
/**
 * Stringify an offset key `object`.
 *
 * @param {Object} object
 *   @property {String} key
 *   @property {Number} index
 * @return {String}
 */


function stringify(object) {
  return object.key + ":" + object.index;
}
/**
 * Export.
 *
 * @type {Object}
 */


export default {
  parse: parse,
  stringify: stringify
};