import React from "react";
import Types from "prop-types";
/**
 * Text.
 *
 * @type {Component}
 */
declare class Text extends React.Component<any, any> {
    /**
     * Property types.
     *
     * @type {Object}
     */
    static propTypes: {
        block: ((...args: any[]) => Error | null) & {
            isRequired: (...args: any[]) => Error | null;
        };
        decorations: Validator<any>;
        editor: Types.Validator<object>;
        node: (...args: any[]) => Error | null;
        parent: (...args: any[]) => Error | null;
        style: Types.Requireable<object>;
    };
    /**
     * Default prop types.
     *
     * @type {Object}
     */
    static defaultProps: {
        style: null;
    };
    /**
     * Debug.
     *
     * @param {String} message
     * @param {Mixed} ...args
     */
    debug: (message: any, ...args: any[]) => void;
    /**
     * Should the node update?
     *
     * @param {Object} nextProps
     * @param {Object} value
     * @return {Boolean}
     */
    shouldComponentUpdate(nextProps: any): boolean;
    /**
     * Render.
     *
     * @return {Element}
     */
    render(): JSX.Element;
    /**
     * Render a single leaf given a `leaf` and `offset`.
     *
     * @param {List<Leaf>} leaves
     * @param {Leaf} leaf
     * @param {Number} index
     * @param {Number} offset
     * @return {Element} leaf
     */
    renderLeaf: (leaves: any, leaf: any, index: any, offset: any) => JSX.Element;
}
/**
 * Export.
 *
 * @type {Component}
 */
export default Text;
