"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.default = void 0;

var _create = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/create"));

var _setPrototypeOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/set-prototype-of"));

var _debug = _interopRequireDefault(require("debug"));

var _react = _interopRequireDefault(require("react"));

var _slatePropTypes = _interopRequireDefault(require("@zykj/slate-prop-types"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _text = _interopRequireDefault(require("./text"));

var __extends = void 0 && (void 0).__extends || function () {
  var extendStatics = function (d, b) {
    extendStatics = _setPrototypeOf.default || {
      __proto__: []
    } instanceof Array && function (d, b) {
      d.__proto__ = b;
    } || function (d, b) {
      for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    };

    return extendStatics(d, b);
  };

  return function (d, b) {
    extendStatics(d, b);

    function __() {
      this.constructor = d;
    }

    d.prototype = b === null ? (0, _create.default)(b) : (__.prototype = b.prototype, new __());
  };
}();

var __spreadArrays = void 0 && (void 0).__spreadArrays || function () {
  for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;

  for (var r = Array(s), k = 0, i = 0; i < il; i++) for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++) r[k] = a[j];

  return r;
};

/**
 * Debug.
 *
 * @type {Function}
 */
var debug = (0, _debug.default)("slate:void");
/**
 * Void.
 *
 * @type {Component}
 */

var Void =
/** @class */
function (_super) {
  __extends(Void, _super);

  function Void() {
    /**
     * Property types.
     *
     * @type {Object}
     */
    var _this = _super !== null && _super.apply(this, arguments) || this;
    /**
     * Debug.
     *
     * @param {String} message
     * @param {Mixed} ...args
     */


    _this.debug = function (message) {
      var args = [];

      for (var _i = 1; _i < arguments.length; _i++) {
        args[_i - 1] = arguments[_i];
      }

      var node = _this.props.node;
      var key = node.key,
          type = node.type;
      var id = key + " (" + type + ")";
      debug.apply(void 0, __spreadArrays([message, "" + id], args));
    };
    /**
     * Render the void node's text node, which will catch the cursor when it the
     * void node is navigated to with the arrow keys.
     *
     * Having this text node there means the browser continues to manage the
     * selection natively, so it keeps track of the right offset when moving
     * across the block.
     *
     * @return {Element}
     */


    _this.renderText = function () {
      var _a = _this.props,
          block = _a.block,
          decorations = _a.decorations,
          node = _a.node,
          readOnly = _a.readOnly,
          editor = _a.editor;
      var child = node.getFirstText();
      return /*#__PURE__*/_react.default.createElement(_text.default, {
        block: node.object == "block" ? node : block,
        decorations: decorations,
        editor: editor,
        key: child.key,
        node: child,
        parent: node,
        readOnly: readOnly
      });
    };

    return _this;
  }
  /**
   * Render.
   *
   * @return {Element}
   */


  Void.prototype.render = function () {
    var props = this.props;
    var children = props.children,
        node = props.node,
        readOnly = props.readOnly;
    var Tag = node.object == "block" ? "div" : "span";
    var style = {
      height: "0",
      color: "transparent",
      outline: "none",
      position: "absolute"
    };

    var spacer = /*#__PURE__*/_react.default.createElement(Tag, {
      "data-slate-spacer": true,
      style: style
    }, this.renderText());

    var content = /*#__PURE__*/_react.default.createElement(Tag, {
      contentEditable: readOnly ? void 0 : false
    }, children);

    this.debug("render", {
      props: props
    });
    return /*#__PURE__*/_react.default.createElement(Tag, {
      "data-slate-void": true,
      "data-key": node.key,
      contentEditable: readOnly || node.object == "block" ? void 0 : false
    }, readOnly ? null : spacer, content);
  };

  Void.propTypes = {
    block: _slatePropTypes.default.block,
    children: _propTypes.default.any.isRequired,
    editor: _propTypes.default.object.isRequired,
    node: _slatePropTypes.default.node.isRequired,
    parent: _slatePropTypes.default.node.isRequired,
    readOnly: _propTypes.default.bool.isRequired
  };
  return Void;
}(_react.default.Component);
/**
 * Export.
 *
 * @type {Component}
 */


var _default = Void;
exports.default = _default;