"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.default = void 0;

var _slate = require("@zykj/slate");

/**
 * Find the DOM node for a `key`.
 *
 * @param {String|Node} key
 * @param {Window} win (optional)
 * @return {Element}
 */
function findDOMNode(key, win) {
  if (win === void 0) {
    win = window;
  }

  if (_slate.Node.isNode(key)) {
    key = key.key;
  }

  var el = win.document.querySelector("[data-key=\"" + key + "\"]");

  if (!el) {
    throw new Error("Unable to find a DOM node for \"" + key + "\". This is often because of forgetting to add `props.attributes` to a custom component.");
  }

  return el;
}
/**
 * Export.
 *
 * @type {Function}
 */


var _default = findDOMNode;
exports.default = _default;