"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.default = void 0;

var _findDomPoint = _interopRequireDefault(require("./find-dom-point"));

/**
 * Find a native DOM range Slate `range`.
 *
 * @param {Range} range
 * @param {Window} win (optional)
 * @return {Object|Null}
 */
function findDOMRange(range, win) {
  if (win === void 0) {
    win = window;
  }

  var anchor = range.anchor,
      focus = range.focus,
      isBackward = range.isBackward,
      isCollapsed = range.isCollapsed;
  var domAnchor = (0, _findDomPoint.default)(anchor, win);
  var domFocus = isCollapsed ? domAnchor : (0, _findDomPoint.default)(focus, win);
  if (!domAnchor || !domFocus) return null;
  var r = win.document.createRange();
  var start = isBackward ? domFocus : domAnchor;
  var end = isBackward ? domAnchor : domFocus;
  r.setStart(start.node, start.offset);
  r.setEnd(end.node, end.offset);
  return r;
}
/**
 * Export.
 *
 * @type {Function}
 */


var _default = findDOMRange;
exports.default = _default;